﻿namespace WPFDependencyPropertySerializationError
{
    using System.Collections.Generic;
    using System;

    [Serializable]
    public class GraphNodeBase : SerializableDependencyObject
    {
        #region Graph Node Members
        protected List<GraphNodeBase> mChildren;
        protected GraphNodeBase mParent;
        #endregion

        #region Constructors
        public GraphNodeBase(GraphNodeBase _parent)
        {
            mChildren = new List<GraphNodeBase>();
            mParent = _parent;
            if (null != mParent)
                mParent.AddChild(this);
        }
        #endregion

        public void AddChild(GraphNodeBase newChild)
        {
            mChildren.Add(newChild);
        }
    }
}
